package com.memorynotfound.jsf;

import javax.faces.component.FacesComponent;
import javax.faces.component.UIComponentBase;
import javax.faces.context.FacesContext;
import javax.faces.context.ResponseWriter;
import java.io.IOException;

@FacesComponent(createTag = true,
        tagName = "custom-output",
        namespace = "http://memorynotfound.com/example",
        value = CustomOutput.FAMILY)
public class CustomOutput extends UIComponentBase {

    protected static final String FAMILY = "com.memorynotfound.jsf.CustomOutput";

    @Override
    public void encodeAll(FacesContext context) throws IOException {
        ResponseWriter writer = context.getResponseWriter();
        writer.startElement("div", this);
        writer.writeAttribute("id", getClientId(context), null);
        writer.writeAttribute("style", "color : red", null);
        String message = (String) this.getAttributes().get("greeting");
        if (message == null){
            writer.writeText("HelloWorld! today is: " + new java.util.Date(), null);
        } else {
            writer.writeText(message, null);
        }
        writer.endElement("div");
    }

    @Override
    public String getFamily() {
        return CustomOutput.FAMILY;
    }
}
